{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Colin Laplace                            *
*                                                    *
*  about.pas : about box                             *
*                                                    *
******************************************************
}

unit about;

interface

uses SysUtils, Classes, QGraphics, QForms, QControls, QStdCtrls,
  QExtCtrls, QDialogs, Version, QMenus, QTypes, QButtons, QClipbrd,
  dev_module;

type
  TAboutBox = class(TForm)
    UrlMenu: TPopupMenu;
    Copy1: TMenuItem;
    CompilerLabel: TLabel;
    GDBLabel: TLabel;
    Panel: TPanel;
    bloodshed_netBtn: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    bugmailLabel: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    CheckForUpdate: TBitBtn;
    CloseBtn: TBitBtn;
    Authors: TBitBtn;
    Panel2: TPanel;
    AppIcon: TImage;
    Bevel1: TBevel;
    NameLabel: TLabel;
    BuildDate: TLabel;
    Version: TLabel;
    Memo1: TMemo;
    procedure AuthorsClick(Sender: TObject);
    procedure CheckForUpdateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure LabelClick(Sender: TObject);
    procedure LabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    UrlString   : string;
    firb        : integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation
uses utils, firbfrm;
{$R *.xfm}

procedure TAboutBox.AuthorsClick(Sender: TObject);
const MessageText =
  'Development:'+#13#10+#13#10+
  '  Colin Laplace'+ #13#10 +
   #13#10 +
  'Big thanks to the GNU and authors of GCC, GDB, Mingw and Free Pascal';
begin
  if firb >= 4 then begin
    try
      FirbForm := TFirbForm.Create(self);
      FirbForm.ShowModal;
    finally
      FirbForm.Free;
    end;
  end;
  MessageDlg(MessageText, MtInformation, [MbOK], 0);
  inc(firb);
end;

procedure TAboutBox.CheckForUpdateClick(Sender: TObject);
begin
//  MainForm.CheckforDevCppUpdatesItemClick(sender);
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  BuildDate.Caption   := 'Build on : ' + DateTimeToStr(FileDateToDateTime(Fileage(Application.ExeName)));
  NameLabel.Caption := Module.Name;
  Version.Caption := 'Version '+Dev_Version;
 // FAQLabel.Left := FAQLabelText.Left+FAQLabelText.Width-1;
end;

procedure TAboutBox.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TAboutBox.Copy1Click(Sender: TObject);
begin
  ClipBoard.AsText := UrlString;
end;

procedure TAboutBox.LabelClick(Sender: TObject);
var s : string;
begin
  if pos('@',(Sender as TLabel).Caption)<> 0 then
     s := 'mailto:'+(Sender as TLabel).Caption
  else s := (Sender as TLabel).Caption;
  ExecuteFile(NETSCAPE, s, false);
end;

procedure TAboutBox.LabelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then begin
     UrlString := (sender as TLabel).Caption;
//     UrlMenu.Popup();
  end;
end;

end.

