{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Colin Laplace                            *
*                                                    *
*  help.pas : Help window                            *
*                                                    *
******************************************************
}

unit help;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QComCtrls, QStdCtrls, QButtons, QExtCtrls, QMenus, QTypes, QClipBrd;

type
  THelpForm = class(TForm)
    TextBrowser: TTextBrowser;
    Panel1: TPanel;
    PrevBtn: TBitBtn;
    NextBtn: TBitBtn;
    CloseBtn: TBitBtn;
    PopupMenu: TPopupMenu;
    Copy1: TMenuItem;
    Selectall1: TMenuItem;
    N1: TMenuItem;
    BackItem: TMenuItem;
    ForwardItem: TMenuItem;
    Home1: TMenuItem;
    HomeBtn: TBitBtn;
    procedure CloseBtnClick(Sender: TObject);
    procedure PrevBtnClick(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure TextBrowserTextChanged(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Home1Click(Sender: TObject);
    procedure ForwardItemClick(Sender: TObject);
    procedure BackItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  HelpForm: THelpForm;

implementation

{$R *.xfm}

procedure THelpForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure THelpForm.PrevBtnClick(Sender: TObject);
begin
  TextBrowser.Backward;
end;

procedure THelpForm.NextBtnClick(Sender: TObject);
begin
  TextBrowser.Forward;
end;

procedure THelpForm.TextBrowserTextChanged(Sender: TObject);
begin
  PrevBtn.Enabled := TextBrowser.CanGoBackward;
  BackItem.Enabled := TextBrowser.CanGoBackward;
  ForwardItem.Enabled := TextBrowser.CanGoForward;
  NextBtn.Enabled := TextBrowser.CanGoForward;
end;

procedure THelpForm.FormActivate(Sender: TObject);
begin
  TextBrowserTextChanged(sender);
end;

procedure THelpForm.Copy1Click(Sender: TObject);
begin
  ClipBoard.AsText := TextBrowser.SelectedText;
end;

procedure THelpForm.Selectall1Click(Sender: TObject);
begin
  TextBrowser.SelectAll;
end;

procedure THelpForm.Home1Click(Sender: TObject);
begin
  TextBrowser.Home;
end;

procedure THelpForm.ForwardItemClick(Sender: TObject);
begin
  TextBrowser.Forward;
end;

procedure THelpForm.BackItemClick(Sender: TObject);
begin
  TextBrowser.Backward;
end;

end.
