{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Colin Laplace                            *
*                                                    *
*  infofrm.pas : Compiling information window        *
*                                                    *
******************************************************
}

unit infofrm;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
 QStdCtrls, QButtons, QExtCtrls;

type
  TInfoForm = class(TForm)
    GroupBox: TGroupBox;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Bevel6: TBevel;
    Bevel2: TBevel;
    OkBtn: TBitBtn;
    ShowResultsBtn: TBitBtn;
    Label3: TLabel;
    Bevel3: TBevel;
    Label4: TLabel;
    ExecBtn: TBitBtn;
    ProjName: TLabel;
    TotalErrors: TLabel;
    SizeFile: TLabel;
    RunParams: TEdit;
    ExeLabel: TLabel;
    MoreBtn: TBitBtn;
    procedure OkBtnClick(Sender: TObject);
    procedure SeeAllOutputClick(Sender: TObject);
    procedure ExecBtnClick(Sender: TObject);
    procedure MoreBtnClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Dclarations prives }
  public
    NewHeight : integer;
    { Dclarations publiques }
  end;

var
  InfoForm: TInfoForm;

implementation

uses Main, outputfrm;

{$R *.xfm}

procedure TInfoForm.OkBtnClick(Sender: TObject);
begin
  FormStyle := fsNormal;
  Close;
end;

procedure TInfoForm.SeeAllOutputClick(Sender: TObject);
begin
  Close;
  OutputForm.Show;
end;

procedure TInfoForm.ExecBtnClick(Sender: TObject);
begin
  MainForm.ExecuteProgram(RunParams.Text);
end;

procedure TInfoForm.MoreBtnClick(Sender: TObject);
begin
  if ExeLabel.Visible then begin
     Height := NewHeight;
     ExeLabel.Visible := False;
     RunParams.Visible := False;
  end
  else begin
     Height := NewHeight+4+ExeLabel.Height+2+RunParams.Height+4;
     ExeLabel.Visible := True;
     RunParams.Visible := True;
  end;
end;

procedure TInfoForm.FormDeactivate(Sender: TObject);
begin
  Height := NewHeight;
  ExeLabel.Visible := False;
  RunParams.Visible := False;
end;

procedure TInfoForm.FormCreate(Sender: TObject);
begin
  NewHeight := Height;
end;

procedure TInfoForm.FormActivate(Sender: TObject);
begin
  if MainForm.IniFile.ReadBool('Options','CompileStayOnTop', False) then
    FormStyle := fsStayOnTop
  else
    FormStyle := fsNormal;
end;


end.
