{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Colin Laplace                            *
*                                                    *
*  main.pas : main IDE window, core of the program   *
*                                                    *
******************************************************
}

unit main;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QTypes, QMenus, QImgList, QComCtrls, QStdCtrls, QExtCtrls, dev_module, editor,
  IniFiles, project, utils, QButtons, QClipBrd;

type
  TMainForm = class(TForm)
    SplitterLeft: TSplitter;
    MessageControl: TPageControl;
    CompSheet: TTabSheet;
    CompilerOutput: TListView;
    MakeSheet: TTabSheet;
    MakeOutput: TListBox;
    LogSheet: TTabSheet;
    LogBox: TMemo;
    ProjectView: TTreeView;
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    NewprojectItem: TMenuItem;
    NewTemplatefile1: TMenuItem;
    N34: TMenuItem;
    OpenprojectItem: TMenuItem;
    ReOpenItem: TMenuItem;
    ClearhistoryItem: TMenuItem;
    N11: TMenuItem;
    N15: TMenuItem;
    NewItem: TMenuItem;
    SaveUnitItem: TMenuItem;
    SaveasItem: TMenuItem;
    SaveallItem: TMenuItem;
    N33: TMenuItem;
    CloseprojectItem: TMenuItem;
    CloseItem: TMenuItem;
    N1: TMenuItem;
    ExporttoItem: TMenuItem;
    HTMLItem: TMenuItem;
    RTFItem: TMenuItem;
    N19: TMenuItem;
    ProjecttoHTMLItem: TMenuItem;
    PrintItem: TMenuItem;
    PrinterSetupItem: TMenuItem;
    N3: TMenuItem;
    ExitItem: TMenuItem;
    EditMenu: TMenuItem;
    UndoItem: TMenuItem;
    RedoItem: TMenuItem;
    N4: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    N14: TMenuItem;
    InsertItem: TMenuItem;
    CommentheaderItem: TMenuItem;
    DateandtimeItem: TMenuItem;
    N26: TMenuItem;
    MainFunctionItem: TMenuItem;
    ToggleBookmarksItem: TMenuItem;
    Bookmark0: TMenuItem;
    Bookmark1: TMenuItem;
    Bookmark2: TMenuItem;
    Bookmark3: TMenuItem;
    Bookmark4: TMenuItem;
    Bookmark5: TMenuItem;
    Bookmark6: TMenuItem;
    Bookmark7: TMenuItem;
    Bookmark8: TMenuItem;
    Bookmark9: TMenuItem;
    GotoBookmarksItem: TMenuItem;
    Bookmark02: TMenuItem;
    Bookmark12: TMenuItem;
    Bookmark22: TMenuItem;
    Bookmark32: TMenuItem;
    Bookmark42: TMenuItem;
    Bookmark52: TMenuItem;
    Bookmark62: TMenuItem;
    Bookmark72: TMenuItem;
    Bookmark82: TMenuItem;
    Bookmark92: TMenuItem;
    N5: TMenuItem;
    SelectallItem: TMenuItem;
    SearchMenu: TMenuItem;
    FindItem: TMenuItem;
    FindnextItem: TMenuItem;
    ReplaceItem: TMenuItem;
    N7: TMenuItem;
    GotolineItem: TMenuItem;
    ViewMenu: TMenuItem;
    ProjectManagerViewItem: TMenuItem;
    StatusbarItem: TMenuItem;
    CompileroutputItem: TMenuItem;
    AlwaysShow: TMenuItem;
    N37: TMenuItem;
    ShowOnlyWhenNeed: TMenuItem;
    ToolbarsItem: TMenuItem;
    MainItem: TMenuItem;
    CompileandRunItem: TMenuItem;
    OptionItem: TMenuItem;
    SpecialsItem: TMenuItem;
    ProjectMenu: TMenuItem;
    NewunitinprojectItem: TMenuItem;
    AddtoprojectItem: TMenuItem;
    RemovefromprojectItem: TMenuItem;
    N6: TMenuItem;
    ProjectoptionsItem: TMenuItem;
    CompileMenu: TMenuItem;
    CompileItem: TMenuItem;
    RunItem: TMenuItem;
    N10: TMenuItem;
    CompilandRunItem: TMenuItem;
    RebuildallItem: TMenuItem;
    N8: TMenuItem;
    DebugItem: TMenuItem;
    OptionsMenu: TMenuItem;
    CompileroptionsItem: TMenuItem;
    EnvironmentoptionsItem: TMenuItem;
    ToolsMenu: TMenuItem;
    CompilingresultsItem: TMenuItem;
    ConfiguretoolsItem: TMenuItem;
    N9: TMenuItem;
    UnixshellItem: TMenuItem;
    SetupCreatorItem: TMenuItem;
    ToolSeparator: TMenuItem;
    HelpDevCppMenu: TMenuItem;
    HelponDevCppItem: TMenuItem;
    TutorialItem: TMenuItem;
    StandardLibraryItem: TMenuItem;
    GNUDebuggerhelpItem: TMenuItem;
    N2: TMenuItem;
    BloodshedSoftwarehomepageItem: TMenuItem;
    N18: TMenuItem;
    CheckforDevCppUpdatesItem: TMenuItem;
    AboutBloodshedDevCppItem: TMenuItem;
    OpenFileDialog: TOpenDialog;
    SaveProject: TSaveDialog;
    OpenAddDialog: TOpenDialog;
    PopupMenu: TPopupMenu;
    ClearPopItem: TMenuItem;
    N31: TMenuItem;
    CopyPopItem: TMenuItem;
    InsertMenu: TPopupMenu;
    CommentheaderPopItem: TMenuItem;
    DateandtimePopItem: TMenuItem;
    N20: TMenuItem;
    MainfunctionPopItem: TMenuItem;
    ToggleMenu: TPopupMenu;
    Bookmark03: TMenuItem;
    Bookmark13: TMenuItem;
    Bookmark23: TMenuItem;
    Bookmark33: TMenuItem;
    Bookmark43: TMenuItem;
    Bookmark53: TMenuItem;
    Bookmark63: TMenuItem;
    Bookmark73: TMenuItem;
    Bookmark83: TMenuItem;
    Bookmark93: TMenuItem;
    GotoMenu: TPopupMenu;
    Bookmark04: TMenuItem;
    Bookmark14: TMenuItem;
    Bookmark24: TMenuItem;
    Bookmark34: TMenuItem;
    Bookmark44: TMenuItem;
    Bookmark54: TMenuItem;
    Bookmark64: TMenuItem;
    Bookmark74: TMenuItem;
    Bookmark84: TMenuItem;
    Bookmark94: TMenuItem;
    UnitPopup: TPopupMenu;
    RemoveFilefromprojectPopItem: TMenuItem;
    RenamefilePopItem: TMenuItem;
    N30: TMenuItem;
    ClosefilePopItem: TMenuItem;
    ProjectPopup: TPopupMenu;
    NewunitinprojectPopItem: TMenuItem;
    AddtoprojectPopItem: TMenuItem;
    RemovefromprojectPopItem: TMenuItem;
    N16: TMenuItem;
    ProjectoptionsPopItem: TMenuItem;
    HelpMenu: TPopupMenu;
    HelponDevCppPopItem: TMenuItem;
    TutorialPopItem: TMenuItem;
    StandardTemplateLibraryguidePopItem: TMenuItem;
    GNUDebuggerhelpPopItem: TMenuItem;
    MenuImages_Gnome: TImageList;
    ExportDialog: TSaveDialog;
    ProjectImage_Gnome: TImageList;
    PageControl: TPageControl;
    TopPanel: TPanel;
    ReplaceDialog: TReplaceDialog;
    FindDialog: TFindDialog;
    SaveFileDialog: TSaveDialog;
    EditPopupMenu: TPopupMenu;
    UndoPopItem: TMenuItem;
    RedoPopItem: TMenuItem;
    MenuItem1: TMenuItem;
    CutPopItem: TMenuItem;
    MenuItem2: TMenuItem;
    PastePopItem: TMenuItem;
    MenuItem3: TMenuItem;
    InsertPopItem: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    TogglebookmarksPopItem: TMenuItem;
    Bookmark01: TMenuItem;
    Bookmark11: TMenuItem;
    Bookmark21: TMenuItem;
    Bookmark31: TMenuItem;
    Bookmark41: TMenuItem;
    Bookmark51: TMenuItem;
    Bookmark61: TMenuItem;
    Bookmark71: TMenuItem;
    Bookmark81: TMenuItem;
    Bookmark91: TMenuItem;
    GotobookmarksPopItem: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem26: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem29: TMenuItem;
    MenuItem30: TMenuItem;
    SelectAllPopItem: TMenuItem;
    StatusBar: TStatusBar;
    MainPanel: TPanel;
    MainToolBar: TToolBar;
    NewProjBtn: TToolButton;
    OpenProjBtn: TToolButton;
    NewFileBtn: TToolButton;
    SaveBtn: TToolButton;
    ToolButton41: TToolButton;
    CloseBtn: TToolButton;
    PrintBtn: TToolButton;
    UndoBtn: TToolButton;
    ToolButton45: TToolButton;
    FindBtn: TToolButton;
    ToolButton57: TToolButton;
    SaveAllBtn: TToolButton;
    CompilePanel: TPanel;
    CompileToolBar: TToolBar;
    CompileBtn: TToolButton;
    ProjOptBtn: TToolButton;
    CompRunBtn: TToolButton;
    Debug: TToolButton;
    ToolButton77: TToolButton;
    AddBtn: TToolButton;
    RemBtn: TToolButton;
    RebuildBtn: TToolButton;
    ToolButton85: TToolButton;
    RunBtn: TToolButton;
    ExtraPanel: TPanel;
    ExtratoolBar: TToolBar;
    Insertbtn: TSpeedButton;
    GotoBtn: TSpeedButton;
    ToggleBtn: TSpeedButton;
    OptionsPanel: TPanel;
    OptionsToolBar: TToolBar;
    CompOpBtn: TToolButton;
    EnvOptBtn: TToolButton;
    CompResBtn: TToolButton;
    SetupBtn: TToolButton;
    HelpBtn: TToolButton;
    AboutBtn: TToolButton;
    CheckBtn: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolsBtn: TToolButton;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    SetmainunitItem: TMenuItem;
    CloseSheet: TTabSheet;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure NewFileBtnClick(Sender: TObject);
    function GetEditor(s : string) : TEditor;
    procedure CloseBtnClick(Sender: TObject);
    procedure AboutBloodshedDevCppItemClick(Sender: TObject);
    procedure CompileroptionsItemClick(Sender: TObject);
    procedure DebugItemClick(Sender: TObject);
    procedure CompilingresultsItemClick(Sender: TObject);
    procedure ProjectoptionsItemClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NewProjBtnClick(Sender: TObject);
    procedure GotolineItemClick(Sender: TObject);
    procedure SelectallItemClick(Sender: TObject);
    procedure CutItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure NewTemplatefile1Click(Sender: TObject);
    procedure ConfiguretoolsItemClick(Sender: TObject);
    procedure ToolsMenuClick(Sender: TObject);
    procedure OnToolClick(sender : TObject);
    function ParseParams(s : string) : string;
    procedure RemovefromprojectItemClick(Sender: TObject);
    procedure OpenProjBtnClick(Sender: TObject);
    procedure OpenFile(FileName : string);
    procedure AddtoprojectItemClick(Sender: TObject);
    procedure HelponDevCppItemClick(Sender: TObject);
    procedure UnixshellItemClick(Sender: TObject);
    procedure EnvOptBtnClick(Sender: TObject);
    procedure SaveUnitItemClick(Sender: TObject);
    procedure SaveasItemClick(Sender: TObject);
    procedure FileMenuClick(Sender: TObject);
    procedure EditMenuClick(Sender: TObject);
    procedure SearchMenuClick(Sender: TObject);
    procedure ProjectMenuClick(Sender: TObject);
    procedure CompileMenuClick(Sender: TObject);
    procedure SaveallItemClick(Sender: TObject);
    procedure CompileBtnClick(Sender: TObject);
    procedure CompileFile;
    procedure CompileProject;
    procedure ClearBeforeCompile;
    procedure ProjectViewItemMouseDown(Sender: TObject;
      Button: TMouseButton; Node: TTreeNode; const Pt: TPoint);
    procedure ClosefilePopItemClick(Sender: TObject);
    procedure CloseprojectItemClick(Sender: TObject);
    procedure CloseProject(HideProjectManager : boolean);
    procedure OpenHistory;
    procedure SaveFileHistory(const Filename : string);
    procedure ClearhistoryItemClick(Sender: TObject);
    procedure OpenHistoryFile(Sender: TObject);
    procedure AddHistory(s : string);
    function SaveBeforeClose(Editor : TEditor) : boolean;
    procedure CommentheaderPopItemClick(Sender: TObject);
    procedure DateandtimePopItemClick(Sender: TObject);
    procedure MainFunctionItemClick(Sender: TObject);
    procedure BloodshedSoftwarehomepageItemClick(Sender: TObject);
    procedure AddItem(c, s1, s2: string);
    procedure ExecuteProgram(Params : string);
    procedure RunItemClick(Sender: TObject);
    procedure ProjectManagerViewItemClick(Sender: TObject);
    procedure StatusbarItemClick(Sender: TObject);
    procedure ViewMenuClick(Sender: TObject);
    procedure ToolbarsItemClick(Sender: TObject);
    procedure MainItemClick(Sender: TObject);
    procedure CompileandRunItemClick(Sender: TObject);
    procedure OptionItemClick(Sender: TObject);
    procedure SpecialsItemClick(Sender: TObject);
    procedure ClearPopItemClick(Sender: TObject);
    procedure CopyPopItemClick(Sender: TObject);
    procedure SetmainunitItemClick(Sender: TObject);
    procedure RemoveFilefromprojectPopItemClick(Sender: TObject);
    procedure RenamefilePopItemClick(Sender: TObject);
    procedure ProjecttoHTMLItemClick(Sender: TObject);
    procedure CompilandRunItemClick(Sender: TObject);
    procedure RebuildBtnClick(Sender: TObject);
    procedure MakeSheetShow(Sender: TObject);
    procedure CompSheetShow(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure ReplaceDialogReplace(Sender: TObject);
    procedure ReplaceDialogFind(Sender: TObject);
    procedure FindItemClick(Sender: TObject);
    procedure ReplaceItemClick(Sender: TObject);
    procedure FindnextItemClick(Sender: TObject);
    procedure UndoItemClick(Sender: TObject);
    procedure RedoItemClick(Sender: TObject);
    procedure InsertbtnClick(Sender: TObject);
    procedure ToggleBtnClick(Sender: TObject);
    procedure GotoBtnClick(Sender: TObject);
    procedure ToggleBookmark(Sender: TObject);
    procedure GotoBookmark(Sender: TObject);
    procedure MessageControlChange(Sender: TObject);
    procedure MessageControlResize(Sender: TObject);
    procedure ShowOnlyWhenNeedClick(Sender: TObject);
    procedure AlwaysShowClick(Sender: TObject);

  private
    { Private declarations }
  public
    IniFile : TIniFile;
    ToolsIniFile : TIniFile;
    DevPath : string;
    Project : TProject;
    CompilerOptionsModified : boolean;
    UntitledCount : integer;
    MessageOriginalHeight : integer;

    procedure OpenMessageSheet;
    procedure CloseMessageSheet;
    procedure OpenCloseMessageSheet;
    { Public declarations }
  end;

var
  MainForm : TMainForm;

implementation

uses version, about, debugfrm, infofrm, projectoptions, line,
  newproject, templatefrm, toolfrm, tooleditfrm, removeunit, help, enviropt,
  outputfrm,
  {$IFDEF CPP}
  cpp_compoptions
  {$ELSE}
  pas_compoptions
  {$ENDIF}
  ;

{$R *.xfm}

function TMainForm.GetEditor(s : string) : TEditor;
var j : integer;
begin
  result := nil;
  for j := 0 to PageControl.PageCount - 1 do
    if ((PageControl.Pages[j] as TEditor).Filename = s) and
       ((PageControl.Pages[j] as TEditor).InProject) then
    begin
      result := (PageControl.Pages[j] as TEditor);
      break;
    end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DevPath := ExtractFilePath(Application.ExeName);
  Module := TDevModule.Create;
  ToolsIniFile := TIniFile.Create(Module.ToolsIniFileName);
  ToolsIniFile.CaseSensitive := false;
  CompilerOptionsModified := True;
  UntitledCount := 0;
  MessageOriginalHeight := MessageControl.Height; 
  IniFile.WriteString('dev', 'Version', DEV_VERSION);
  OpenHistory;
  IniFile.UpdateFile;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  MainForm.Caption := Module.Name + ' ' + DEV_VERSION;
  ExitItem.Caption := 'Exit ' + Module.Name;
  HelpOnDevCppItem.Caption := 'Help on ' + Module.Name;
  CheckforDevCppUpdatesItem.Caption := 'Check for ' + Module.Name + ' updates';
  AboutBloodshedDevCppItem.Caption := 'About ' + Module.Name;
  Application.Title := MainForm.Caption;
  {$IFDEF PAS}
  SetmainunitItem.Visible := True;
  OpenFileDialog.Filter :=
  'Dev Project files (*.dev)|'+
  'Pascal files (*.pas;*.pp)|'+
  'All files (*.*)';
  {$ENDIF}
  OpenAddDialog.Filter := Module.Filter;
  SaveFileDialog.Filter := Module.Filter;
end;

procedure TMainForm.NewFileBtnClick(Sender: TObject);
var  NewEditor : TEditor;
begin
  inc(UntitledCount);
  NewEditor := TEditor.Create(self);
  if ProjectOpen then
    Project.NewUnit(False)
  else                  
    NewEditor.Init(false, UNTITLED+IntToStr(UntitledCount), '', False);
  PageControl.InsertControl(NewEditor);
  PageControl.ActivePage := NewEditor;
end;

procedure TMainForm.CloseBtnClick(Sender: TObject);
var index : integer;
begin
  index := -1;
  if PageControl.ActivePageIndex <> -1 then begin
     if ProjectOpen then
       index := Project.GetUnitFromEditor(PageControl.ActivePage as TEditor);
     if SaveBeforeClose(PageControl.ActivePage as TEditor) then begin
       // bug during free
       with PageControl do begin
         // firb trick
         (Pages[PageControl.ActivePage.PageIndex] as TEditor).VIsible := false;
         (Pages[PageControl.ActivePage.PageIndex] as TEditor).TabVisible := False;
         //(Pages[PageControl.ActivePage.PageIndex] as TEditor).Free;
       end;
       if index > -1 then
         Project.Units[index].Editor := nil;
     end;
  end;
end;

procedure TMainForm.AboutBloodshedDevCppItemClick(Sender: TObject);
begin
  try
    AboutBox := TAboutBox.Create(self);
    AboutBox.ShowModal;
  finally
    AboutBox.Free;
  end;
end;

procedure TMainForm.CompileroptionsItemClick(Sender: TObject);
begin
  try
    {$IFDEF CPP}
    Module.CompOptForm := TCpp_CompForm.Create(self);
    {$ELSE}
    Module.CompOptForm := TPas_CompForm.Create(self);
    {$ENDIF}
    Module.CompOptForm.ShowModal;
  finally
    Module.CompOptForm.Free;
  end;
end;

procedure TMainForm.DebugItemClick(Sender: TObject);
begin
  try
    DbgForm := TDbgForm.Create(self);
    if DbgForm.ShowModal = mrOk then
      ExecuteFile(Module.Term, '-e '+Module.Gdb, false);
  finally
    DbgForm.Free;
  end;
end;

procedure TMainForm.CompilingresultsItemClick(Sender: TObject);
begin
  if ProjectOpen then begin
     if FileExists(Project.GetExecutableName) then
        InfoForm.ExecBtn.enabled := True
     else
        InfoForm.ExecBtn.enabled := False;
  end
  else if PageControl.ActivePageIndex > -1 then begin
    if FileExists(ChangeFileExt((PageControl.ActivePage as TEditor).Filename, '')) then
      InfoForm.ExecBtn.enabled := True
    else
      InfoForm.ExecBtn.enabled := False;
  end;
  InfoForm.Show;
end;

procedure TMainForm.ProjectoptionsItemClick(Sender: TObject);
begin
  if not ProjectOpen then exit;
  try
    ProjectOpt := TProjectOpt.Create(self);
    {$IFDEF CPP}
    ProjectOpt.CompileCpp.Checked := Project.UseGpp;
    {$ENDIF}
    ProjectOpt.ObjFileName.Text := Project.ObjFiles;
    ProjectOpt.ProjectName.Text := Project.Name;
    ProjectOpt.NoConsole.Checked := Project.NoConsole;
    ProjectOpt.DynLib.Checked := Project.DynamicLib;
    ProjectOpt.StaticLib.Checked := Project.StaticLib;
    ProjectOpt.IncDir.Text := Project.IncludeDirs;
    ProjectOpt.Extralib.Text := Project.Libs;
    ProjectOpt.CompilerOpt.Text := Project.CompilerOptions;
    if ProjectOpt.ShowModal = mrOK then begin
      Project.Write('name', ProjectOpt.ProjectName.Text);
      Project.Node.Text := ProjectOpt.ProjectName.Text;
      Project.Write('objfile', ProjectOpt.ObjfileName.Text);
      Project.Write('libs', ProjectOpt.Extralib.Text);
      Project.Write('includedirs', ProjectOpt.IncDir.Text);
      Project.Write('compileroptions', ProjectOpt.CompilerOpt.Text);
      Project.WriteBool('noconsole', ProjectOpt.NoConsole.Checked);
      Project.WriteBool('static', ProjectOpt.StaticLib.Checked);
      Project.WriteBool('dynamic', ProjectOpt.DynLib.Checked);
      {$IFDEF CPP}
      Project.WriteBool('usegpp', ProjectOpt.CompileCpp.Checked);
      {$ENDIF}
      Project.Save;
      Project.Update;
    end;
  finally
    ProjectOpt.Free;
  end;
end;

procedure TMainForm.ExitItemClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  IniFile.UpdateFile;
  IniFile.Free;
  if ProjectOpen then
    CloseProject(false);
end;

procedure TMainForm.NewProjBtnClick(Sender: TObject);
var DoSave : boolean;
begin
  DoSave := True;
  if ProjectOpen then
     if (MessageDlg('Are you sure you want to close "'+Project.Name+'" and create a new project ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
       CloseprojectItemClick(Sender)
     else exit;
  try
    NewProjForm := TNewProjForm.Create(Application);
    if (NewProjForm.ShowModal = mrOK) and (SaveProject.Execute) then begin
      if FileExists(SaveProject.FileName) then begin
        DoSave := false;
        if MessageDlg('Overwrite ?', 'File exists, overwrite ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          DoSave := true;
      end;
      if DoSave then begin
        if not IniFile.ReadBool('Options','NoProjExpl', False) then
          ProjectView.Visible := True;
        Project := TProject.Create(SaveProject.Filename, NewProjForm.NameEdit.Text);
        Project.NewUnit(True);
        case NewProjForm.ProjView.Selected.Index of
          0, 4 : Project.NoConsole := False;
          1 : Project.NoConsole := True;
          2 : Project.StaticLib := True;
          3 : Project.DynamicLib := True;
        end;
        {$IFDEF CPP}
        Project.UseGpp := NewProjForm.CppBtn.Checked;
        {$ENDIF}
        Project.UpdateFile;
        SaveFileHistory(Project.FileName);
      end;
    end;
  finally
    NewProjForm.Free;
  end;
end;

procedure TMainForm.GotolineItemClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex > -1 then
    try
      LineForm := TLineForm.Create(self);
      if LineForm.ShowModal = mrOK then
        with (PageControl.ActivePage as TEditor) do begin
          Text.CaretY := LineForm.Line.Value;
          Text.EnsureCursorPosVisible;
        end;
    finally
      LineForm.Free;
    end;
end;

procedure TMainForm.SelectallItemClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex > -1 then
    (PageControl.ActivePage as TEditor).Text.SelectAll;
end;

procedure TMainForm.CutItemClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex > -1 then
    (PageControl.ActivePage as TEditor).Text.CutToClipboard;
end;

procedure TMainForm.CopyItemClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex > -1 then
    (PageControl.ActivePage as TEditor).Text.CopyToClipboard
end;

procedure TMainForm.PasteItemClick(Sender: TObject);
begin
  if PageControl.ActivePageIndex > -1 then
    (PageControl.ActivePage as TEditor).Text.PasteFromClipboard;
end;

procedure TMainForm.CloseProject(HideProjectManager : boolean);
var i : integer;
begin
  if ProjectOpen then begin
    for i := 0 to Project.UnitCount - 1 do
      if Project.Units[i].Editor <> nil then begin
         // firb trick
         with PageControl do begin
           (Pages[PageControl.ActivePage.PageIndex] as TEditor).Visible := false;
           (Pages[PageControl.ActivePage.PageIndex] as TEditor).TabVisible := False;
         end;
         // bug during free
         PageControl.Pages[Project.Units[i].Editor.TabIndex].Free;
         Project.Units[i].Editor := nil;
      end;
    Project.Free;
    if HideProjectManager then
      ProjectView.visible := False;
  end;
end;

procedure TMainForm.NewTemplatefile1Click(Sender: TObject);
begin
  TemplateForm.Show;
end;

procedure TMainForm.ConfiguretoolsItemClick(Sender: TObject);
begin
  try
    ToolForm := TToolForm.Create(self);
    ToolEditForm := TToolEditForm.Create(self);
    ToolForm.ShowModal;
  finally
    ToolForm.Free;
    ToolEditForm.Free;
  end;
end;

procedure TMainForm.ToolsMenuClick(Sender: TObject);
var i, Toolcount : integer;
    m : TMenuItem;
const ToolMenuItemCount = 6;
begin
  i := ToolsMenu.Count - 1;
  if ToolsMenu.Count > ToolMenuItemCount then
     repeat
       ToolsMenu.Remove(ToolsMenu.Items[i]);
       dec(i);
     until ToolsMenu.Count = ToolMenuItemCount;

  ToolCount := ToolsIniFile.ReadInteger('Tools','Count',0);
  if ToolCount = 0 then
     exit;

  for i := 1 to ToolCount do begin
      M := TMenuItem.Create(MainMenu);
      M.Caption := ToolsIniFile.ReadString(IntToStr(i),'Title','No title');
      M.Tag := i;
      M.OnClick := OnToolClick;
      ToolsMenu.Add(M);
  end;
end;

function TMainForm.ParseParams(s : string) : string;
var tmp : string;
begin
  if ProjectOpen then begin
    while pos('<EXENAME>', s) <> 0 do begin
      Insert(ChangeFileExt(s, ''), s, pos('<EXENAME>',s));
      Delete(s, pos('<EXENAME>', s), length('<EXENAME>'));
    end;

    while pos('<PROJECTNAME>', s) <> 0 do begin
      Insert(Project.FileName, s, pos('<PROJECTNAME>',s));
      Delete(s, pos('<PROJECTNAME>', s), length('<PROJECTNAME>'));
    end;

    tmp := ExtractFilePath(Project.FileName);
    while pos('<PROJECTPATH>', s) <> 0 do begin
      Insert(tmp, s, pos('<PROJECTPATH>',s));
      Delete(s, pos('<PROJECTPATH>', s), length('<PROJECTPATH>'));
    end;
  end
  else if PageControl.PageCount > 0 then begin
    tmp := ChangeFileExt((PageControl.ActivePage as TEditor).FileName,'');
    while pos('<EXENAME>', s) <> 0 do begin
      Insert(tmp, s, pos('<EXENAME>',s));
      Delete(s, pos('<EXENAME>', s), length('<EXENAME>'));
    end;
    tmp := (PageControl.ActivePage as TEditor).FileName;
    while pos('<PROJECTNAME>', s) <> 0 do begin
      Insert(tmp, s, pos('<PROJECTNAME>',s));
      Delete(s, pos('<PROJECTNAME>', s), length('<PROJECTNAME>'));
    end;
    tmp := ExtractFilePath(((PageControl.ActivePage as TEditor).FileName));
    while pos('<PROJECTPATH>', s) <> 0 do begin
      Insert(tmp, s, pos('<PROJECTPATH>',s));
      Delete(s, pos('<PROJECTPATH>', s), length('<PROJECTPATH>'));
    end;
  end;

  if PageControl.PageCount > 0 then
     tmp := (PageControl.ActivePage as TEditor).FileName
  else tmp := '';
  while pos('<CURRENTSOURCENAME>', s) <> 0 do begin
    Insert(tmp, s, pos('<CURRENTSOURCENAME>',s));
    Delete(s, pos('<CURRENTSOURCENAME>', s), length('<CURRENTSOURCENAME>'));
  end;
  Result := s;
end;

procedure TMainForm.OnToolClick(sender : TObject);
var Params : string;
begin
  Params := ParseParams(ToolsIniFile.ReadString(IntToStr((Sender as TMenuItem).Tag), 'Params', ''));
  ExecuteFile(ToolsIniFile.ReadString(IntToStr((Sender as TMenuItem).Tag), 'Program', ''), Params, false);
end;

procedure TMainForm.RemovefromprojectItemClick(Sender: TObject);
var i : integer;
    tmp : string;
begin
  if ProjectOpen then begin
     RemoveUnitForm := TRemoveUnitForm.Create(Self);
     for i := 0 to Project.UnitCount - 1 do begin
       tmp := Project.Units[i].FileName;
       try
         RemoveUnitForm.UnitList.Items.Add(tmp);
       except
         MessageDlg('There was an exception while trying to read your project file', MtError,[MbOK],0);
       end;
     end;
     if (RemoveUnitForm.ShowModal = MrOK) and (RemoveUnitForm.UnitList.ItemIndex > -1) then
       Project.Remove(RemoveUnitForm.UnitList.ItemIndex);
     RemoveUnitForm.Free;
  end;
end;

procedure TMainForm.OpenFile(FileName : string);
var NewEditor : TEditor;
begin
  NewEditor := TEditor.Create(self);
  NewEditor.Init(false, FileName, FileName, true);
end;

procedure TMainForm.OpenProjBtnClick(Sender: TObject);
begin
  if OpenFileDialog.Execute then begin
    if ExtractFileExt(OpenFileDialog.FileName) = '.dev' then begin
      if ProjectOpen then begin
        if (MessageDlg('Are you sure you want to close "'+Project.Name+'" and create a new project ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
         CloseProject(false)
        else exit;
      end;
      Project := TProject.Create(OpenFileDialog.FileName, '$__DEVINTERNAL_OPEN');
      if not IniFile.ReadBool('Options','NoProjExpl', False) then
        ProjectView.Visible := True;
    end
    else
      OpenFile(OpenFileDialog.FileName);
    AddHistory(OpenFileDialog.FileName);
    SaveFileHistory(OpenFileDialog.FileName);
  end;
end;

procedure TMainForm.AddtoprojectItemClick(Sender: TObject);
var i : integer;
begin
  if ProjectOpen and OpenAddDialog.Execute then begin
    for i := 0 to OpenAddDialog.Files.Count-1 do
      if Project.FileAlreadyExists(OpenAddDialog.Files[i]) then
         MessageDlg('A file named "'+ExtractFileName(OpenAddDialog.Files[i])+'" already exists in '+Project.Name+'.'+#13'Please specify another filename.', MtError, [mbOK],0)
      else
        Project.AddUnit(OpenAddDialog.Files[i]);
  end;
end;

procedure TMainForm.HelponDevCppItemClick(Sender: TObject);
begin
  HelpForm.Show;
  HelpForm.TextBrowser.FileName := DevPath + '/docs/index.html';
end;

procedure TMainForm.UnixshellItemClick(Sender: TObject);
begin
  ExecuteFile(Module.Term, '', false);
end;

procedure TMainForm.EnvOptBtnClick(Sender: TObject);
begin
  try
    EnvirForm := TEnvirForm.Create(self);
    EnvirForm.ShowModal;
  finally
    EnvirForm.Free;
  end;
end;

procedure TMainForm.SaveUnitItemClick(Sender: TObject);
var Ed : TEditor;
begin
  if Sender is TEditor then
    Ed := Sender as TEditor
  else
    Ed := PageControl.ActivePage as TEditor;
  if (PageControl.PageCount > 0) then begin
     if Ed.New or (Ed.FileName = '') then
        SaveAsItemClick(sender)
     else if Ed.Text.Modified then begin
        Ed.Text.Lines.SaveToFile(Ed.FileName);
        Ed.Modified := False;
        StatusBar.Panels[1].Text := '';
     end;
  end;
end;

procedure TMainForm.SaveasItemClick(Sender: TObject);
var Ed : TEditor;
begin
  if Sender is TEditor then
    Ed := Sender as TEditor
  else
    Ed := PageControl.ActivePage as TEditor;
  if (PageControl.PageCount > 0) then begin
    SaveFileDialog.FileName := Ed.FileName;
    {$IFDEF CPP}
    if (ProjectOpen) then begin
      if Project.UseGpp then
        SaveFileDialog.FilterIndex := 1
      else SaveFileDialog.FilterIndex := 2;
    end;
    {$ENDIF}
    if (not SaveFileDialog.Execute) then exit;
    if FileExists(SaveFileDialog.FileName) then
       if (MessageDlg('Overwrite ?', 'File exists, overwrite ?', mtConfirmation, [mbYes, mbNo], 0) = mrNo) then
         exit;
    Ed.FileName := SaveFileDialog.FileName;
    Ed.Text.Lines.SaveToFile(SaveFileDialog.FileName);
    if Ed.InProject then begin
      Ed.Caption := ExtractFileName(Ed.FileName);
      Project.SaveUnitAs(Project.GetUnitFromEditor(Ed), Ed.Filename);
    end
    else
      Ed.Caption := Ed.FileName;
    Ed.New := False;
    Ed.Modified := False;
    StatusBar.Panels[1].Text := '';
  end;
end;

procedure TMainForm.FileMenuClick(Sender: TObject);
begin
  SaveUnitItem.Enabled := PageControl.PageCount > 0;
  SaveasItem.Enabled := PageControl.PageCount > 0;
  SaveAllItem.Enabled := PageControl.PageCount > 0;
  CloseProjectItem.Enabled := ProjectOpen;
  CloseItem.Enabled := PageControl.PageCount > 0;
  PrintItem.Enabled := PageControl.PageCount > 0;
end;

procedure TMainForm.EditMenuClick(Sender: TObject);
begin
  UndoItem.Enabled := PageControl.PageCount > 0;
  RedoItem.Enabled := PageControl.PageCount > 0;
  CutItem.Enabled := PageControl.PageCount > 0;
  CopyItem.Enabled := PageControl.PageCount > 0;
  PasteItem.Enabled := PageControl.PageCount > 0;
  InsertItem.Enabled := PageControl.PageCount > 0;
  ToggleBookmarksItem.Enabled := PageControl.PageCount > 0;
  GotoBookmarksItem.Enabled := PageControl.PageCount > 0;
  SelectallItem.Enabled := PageControl.PageCount > 0;
end;

procedure TMainForm.SearchMenuClick(Sender: TObject);
begin
  FindItem.Enabled := PageControl.PageCount > 0;
  FindNextItem.Enabled := PageControl.PageCount > 0;
  ReplaceItem.Enabled := PageControl.PageCount > 0;
  GotoLineItem.Enabled := PageControl.PageCount > 0;
end;

procedure TMainForm.ProjectMenuClick(Sender: TObject);
begin
  NewUnitInProjectItem.Enabled := ProjectOpen;
  AddtoprojectItem.Enabled := ProjectOpen;
  RemoveFromProjectItem.Enabled := ProjectOpen;
  ProjectOptionsItem.Enabled := ProjectOpen;
  {$IFDEF PAS}
  SetMainUnitItem.Enabled := ProjectOpen;
  {$ENDIF}
end;

procedure TMainForm.CompileMenuClick(Sender: TObject);
begin
  CompileItem.Enabled := (PageControl.PageCount > 0) or ProjectOpen;
  RunItem.Enabled := (PageControl.PageCount > 0) or ProjectOpen;
  CompilandRunItem.Enabled := (PageControl.PageCount > 0) or ProjectOpen;
  RebuildAllItem.Enabled := (PageControl.PageCount > 0) or ProjectOpen;
  DebugItem.Enabled := (PageControl.PageCount > 0) or ProjectOpen;
end;

procedure TMainForm.SaveallItemClick(Sender: TObject);
var i : integer;
begin
  for i := 0 to PageControl.PageCount - 1 do begin
    if (PageControl.Pages[i] as TEditor).New then
      SaveAsItemClick(PageControl.Pages[i] as TEditor)
    else if (PageControl.Pages[i] as TEditor).Text.Modified then
      SaveUnitItemClick(PageControl.Pages[i] as TEditor);
  end;
end;

procedure TMainForm.CompileBtnClick(Sender: TObject);
begin
  ClearBeforeCompile;
  if ProjectOpen then
    CompileProject
  else if PageControl.PageCount > 0 then
    CompileFile;
end;

procedure TMainForm.ClearBeforeCompile;
var i : integer;
begin
  CompilerOutPut.Items.Clear;
  CompSheet.Highlighted := false;
  MakeOutput.Items.Clear;
  MakeSheet.Highlighted := false;
  LogBox.Lines.Clear;
  OutputForm.Output.Clear;
  for i := 0 to InfoForm.ComponentCount - 1 do
    if InfoForm.Components[i] is TBitBtn then
      (InfoForm.Components[i] as TBitBtn).Enabled := False;
end;

procedure TMainForm.CompileFile;
var CompilerStr, BinStr, Args : string;
begin
  if (PageControl.ActivePageIndex <= -1) then exit;
  if (PageControl.ActivePage as TEditor).FileName = '' then begin
    SaveUnititemClick(PageControl.ActivePage as TEditor);
    if (PageControl.ActivePage as TEditor).FileName = '' then
      exit;
  end;
  BinStr := ChangeFileExt((PageControl.ActivePage as TEditor).FileName, '');
  ClearBeforeCompile;
  InfoForm.Caption := 'Compiling...';
  InfoForm.ProjName.Caption := (PageControl.ActivePage as TEditor).FileName;
  InfoForm.Show;
  LogBox.Lines.Add('Compiling...');
  Application.ProcessMessages;
  {$IFDEF CPP}
  if ExtractFileExt((PageControl.ActivePage as TEditor).FileName) = '.cpp' then
    CompilerStr := Module.CppCompiler
  else
    CompilerStr := Module.Compiler;
  Args := (PageControl.ActivePage as TEditor).FileName + ' -o ' + BinStr;
  {$ELSE}
  CompilerStr := Module.Compiler;
  Args := (PageControl.ActivePage as TEditor).FileName + ' -o' + BinStr;
  {$ENDIF}
  LogBox.Lines.Add(CompilerStr + ' ' + Args);
  ExecuteRedirFile(CompilerStr, Args, Module.ConfDir + DEV_COMPILELOG, true);
  InfoForm.Caption := 'Terminated';
  Module.AnalyseOutput(BinStr);
end;

procedure TMainForm.CompileProject;
begin
  if Project.StaticLib then
    Module.CreateStaticMakefile
  else if Project.DynamicLib then
    Module.CreateDynamicMakeFile
  else
    Module.CreateMakeFile;
  InfoForm.Caption := 'Compiling project...';
  InfoForm.ProjName.Caption := Project.FileName;
  InfoForm.Show;
  Application.ProcessMessages;
  chdir(ExtractFilePath(Project.FileName));
  Logbox.Lines.Add('Executing ''make''...');
  LogBox.Lines.Add(Module.Make+ ' -f '+ExtractFilePath(Project.FileName) + DEV_MAKEFILE+' all');
  ExecuteRedirFile(Module.Make, '-f '+ExtractFilePath(Project.FileName) + DEV_MAKEFILE+' all', Module.ConfDir + DEV_COMPILELOG, true);
  Module.AnalyseOutput(Project.GetExecutableName);
  InfoForm.Caption := 'Terminated';
end;

procedure TMainForm.ProjectViewItemMouseDown(Sender: TObject;
  Button: TMouseButton; Node: TTreeNode; const Pt: TPoint);
var i : integer;
begin
  if (not ProjectOpen) then
      exit;
  if Node = ProjectView.TopItem then
     ProjectPopup.Popup(pt.X, pt.Y)
  else if Button = mbRight then
     UnitPopup.Popup(pt.X, pt.Y)
  else begin
      for i := 0 to Project.UnitCount - 1 do
        if Project.Units[i].Node = Node then begin
           if Project.Units[i].Editor <> nil then begin
             PageControl.ActivePage := Project.Units[i].Editor;
             Application.ProcessMessages;
             Project.Units[i].Editor.SetFocus;
           end
           else
             Project.OpenUnit(i);
           break;
        end;
  end;
end;

procedure TMainForm.ClosefilePopItemClick(Sender: TObject);
var i : integer;
begin
  for i := 0 to Project.UnitCount - 1 do
    if Project.Units[i].Node = ProjectView.Selected then begin
       if Project.Units[i].Editor <> nil then begin
         PageControl.Pages[Project.Units[i].Editor.TabIndex].Destroy;
         Project.Units[i].Editor := nil;
       end;
       break;
    end;
end;

procedure TMainForm.CloseprojectItemClick(Sender: TObject);
begin
  CloseProject(True);
end;

procedure TMainForm.OpenHistory;
var
   List    : TStringList;
   i       : integer;
begin
  i := ReOpenItem.Count - 1;
  if ReOpenItem.Count <> 2 then
     while i <> 2 do begin
       ReOpenItem.Remove(ReOpenItem.Items[i]);
       dec(i);
     end;
  List := TStringList.Create;
  IniFile.ReadSectionValues('History',List);
  for i := 0 to List.Count-1 do
    if FileExists(List.Values[IntToStr(I)]) then
       AddHistory(List.Values[IntToStr(I)]);
  List.Free;
end;

procedure TMainForm.AddHistory(s : string);
var
   NewMenuItem : TMenuItem;
   i : integer;
begin
  for i := 2 to ReOpenItem.Count-1 do
      if lowercase(ReOpenItem.Items[i].Caption) = lowercase(s) then
         exit;
  NewMenuItem := TMenuItem.Create(Self);
  NewMenuItem.Caption := s;
  NewMenuItem.OnClick := OpenHistoryFile;
  ReOpenItem.Insert(2,NewMenuItem);
end;

procedure TMainForm.OpenHistoryFile(Sender: TObject);
var s : string;
begin
  s := (Sender as TMenuItem).Caption;
  if lowercase(ExtractFileExt(s)) = '.dev' then begin
      if ProjectOpen then begin
        if (MessageDlg('Are you sure you want to close "'+Project.Name+'" and open another project ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
         CloseProject(false)
        else exit;
      end;
      Project := TProject.Create(s, '$__DEVINTERNAL_OPEN');
      if not IniFile.ReadBool('Options','NoProjExpl', False) then
        ProjectView.Visible := True;
  end
  else
    OpenFile(s);
end;

procedure TMainForm.SaveFileHistory(const Filename : string);
var
   LastNum, i : integer;
   List : TStringList;
begin
  List := TStringList.Create;
  IniFile.ReadSectionValues('History', List);
  for i := 0 to List.Count-1 do
    if List.Values[IntToStr(i)]= Filename then begin
       List.Free;
       exit;
    end;
  LastNum := IniFile.ReadInteger('History', 'Last', 0);
  IniFile.WriteInteger('History', 'Last', LastNum + 1);
  IniFile.WriteString('History', IntToStr(LastNum + 1), Filename);
  IniFile.UpdateFile;
end;

procedure TMainForm.AddItem(c, s1, s2: string);
var
  ListItem: TListItem;
begin
  ListItem := CompilerOutput.Items.Add;
  ListItem.Caption := c;
  ListItem.SubItems.Add(s1);
  ListItem.SubItems.Add(s2);
end;

procedure TMainForm.ClearhistoryItemClick(Sender: TObject);
var i : integer;
begin
  IniFile.EraseSection('History');
  i := ReOpenItem.Count - 1;
  if ReOpenItem.Count <> 2 then
    while ReOpenItem.Count <> 2 do begin
       ReOpenItem.Remove(ReOpenItem.Items[i]);
       dec(i);
    end;
  IniFile.UpdateFile;
end;


function TMainForm.SaveBeforeClose(Editor : TEditor) : boolean;
var res : integer;
begin
  result := true;
  if Editor.Text.Modified then begin
    res := MessageDlg('File '+Editor.Caption+' has been modifie. Save it before closing ?',
                      mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    case res of
    mrYes : begin
              SaveUnitItemClick(Editor);
              result := true;
            end;
    mrNo  : result := true;
    mrCancel : result := false;
    end;
  end;
end;

procedure TMainForm.CommentheaderPopItemClick(Sender: TObject);
begin
  if PageControl.ActivePageindex > - 1 then begin
    (PageControl.ActivePage as TEditor).Text.SelText :=
                   '/* '+#10+
                    '   Name : ' +#10+
                    '   Author : ' +#10+
                    '   Description : ' +#10+
                    '   Date : ' +#10+
                    '   Copyright : ' +#10+
                    '*/' +#10;
  end;
end;

procedure TMainForm.DateandtimePopItemClick(Sender: TObject);
begin
  if PageControl.ActivePageindex > - 1 then
    (PageControl.ActivePage as TEditor).Text.SelText := FormatDateTime('dd/mm/yy hh:nn',Now);
end;

procedure TMainForm.MainFunctionItemClick(Sender: TObject);
begin
  if PageControl.ActivePageindex > - 1 then
    (PageControl.ActivePage as TEditor).Text.SelText := Module.MainCode;
end;

procedure TMainForm.BloodshedSoftwarehomepageItemClick(Sender: TObject);
begin
  ExecuteFile(NETSCAPE, 'http://www.bloodshed.net', false);
end;

procedure TMainForm.ExecuteProgram(Params : string);
var F : TextFile;
begin
  if Projectopen then begin
    if not FileExists(Project.GetExecutableName) then begin
      MessageDlg('Project has not been successfully compiled yet', mtInformation, [mbOK], 0);
      exit;
    end;
  end
  else if not FileExists(ChangeFileExt((PageControl.ActivePage as TEditor).Filename, '')) then begin
      MessageDlg('File has not been successfully compiled yet', mtInformation, [mbOK], 0);
      exit;
  end;
{  if IniFile.ReadBool('Options', 'Minimize', True) then begin
    Application.Minimize;
    Application.ProcessMessages;
    Wait := True;
  end;}
  AssignFile(F, Module.ConfDir+DEV_RUN);
  Rewrite(F);
  if ProjectOpen then
    writeln(F, Project.GetExecutableName+' '+Params)
  else writeln(F, ChangeFileExt((PageControl.ActivePage as TEditor).Filename, '') +' '+Params);
  writeln(F, 'echo "[ Press Enter key to close ]"');
  writeln(F, 'read');
  CloseFile(F);
  PutXMode(Module.ConfDir+DEV_RUN);
  if ProjectOpen then begin    // this nested 'if' is necessary the compiler is performing an operation it shouldn't evaluate -> seg fault
    if (not Project.StaticLib) and (not Project.DynamicLib) then
       ExecuteFile(Module.Term, '-e '+Module.ConfDir+DEV_RUN, false)
  end
  else if not ProjectOpen then
    ExecuteFile(Module.Term, '-e '+Module.ConfDir+DEV_RUN, false);
{  if wait then
    Application.Restore;}
end;

procedure TMainForm.RunItemClick(Sender: TObject);
begin
  ExecuteProgram('');
end;

procedure TMainForm.ProjectManagerViewItemClick(Sender: TObject);
begin
  ProjectManagerViewItem.Checked := not ProjectManagerViewItem.Checked;
  ProjectView.Visible := ProjectManagerViewItem.Checked;
end;

procedure TMainForm.StatusbarItemClick(Sender: TObject);
begin
  StatusBarItem.Checked := not StatusBarItem.Checked;
  StatusBar.Visible := StatusBarItem.Checked;
end;

procedure TMainForm.ViewMenuClick(Sender: TObject);
begin
  ProjectManagerViewItem.Checked := ProjectView.Visible;
  StatusBarItem.Visible := StatusBar.Visible;
end;

procedure TMainForm.ToolbarsItemClick(Sender: TObject);
begin
  MainItem.Checked := MainPanel.Visible;
  CompileandRunItem.Checked := CompilePanel.visible;
  OptionItem.Checked := OptionsPanel.Visible;
  SpecialsItem.Checked := ExtraPanel.Visible;
end;

procedure TMainForm.MainItemClick(Sender: TObject);
begin
  MainItem.Checked := not MainItem.Checked;
  MainPanel.Visible := MainItem.Checked;
end;

procedure TMainForm.CompileandRunItemClick(Sender: TObject);
begin
  CompileandRunItem.Checked := not CompileandRunItem.Checked;
  CompilePanel.Visible := CompileandRunItem.Checked;
end;

procedure TMainForm.OptionItemClick(Sender: TObject);
begin
  OptionItem.Checked := not OptionItem.Checked;
  OptionsPanel.Visible := OptionItem.Checked;
end;

procedure TMainForm.SpecialsItemClick(Sender: TObject);
begin
  SpecialsItem.Checked := not SpecialsItem.Checked;
  ExtraPanel.Visible := SpecialsItem.Checked;
end;

procedure TMainForm.ClearPopItemClick(Sender: TObject);
begin
  CompilerOutput.Items.Clear;
end;

procedure TMainForm.CopyPopItemClick(Sender: TObject);
begin
  if CompilerOutput.ItemFocused <> nil then
     ClipBoard.AsText := 'Line '+CompilerOutput.ItemFocused.Caption +
                         'in file "'+CompilerOutput.ItemFocused.SubItems[0]+'" : '+
                          CompilerOutput.ItemFocused.SubItems[1];
end;

procedure TMainForm.SetmainunitItemClick(Sender: TObject);
{$IFDEF PAS}
var i : integer;
{$ENDIF}
begin
  {$IFDEF PAS}
  try
    RemoveUnitForm := TRemoveUnitForm.Create(self);
    with RemoveUnitForm do begin
      Caption := 'Set main unit';
      GroupBox.Caption := 'Select your project''s main unit file :';
      for i := 0 to Project.UnitCount - 1 do begin
       try
         UnitList.Items.Add(Project.Units[i].FileName);
         if Project.Units[i].FileName = Project.MainUnit then
           UnitList.ItemIndex := i;
       except
         MessageDlg('There was an exception while trying to read your project file', MtError,[MbOK],0);
       end;
     end;
     if (ShowModal = mrOK) and (UnitList.ItemIndex > - 1)  then begin
        Project.MainUnit := UnitList.Items[UnitList.ItemIndex];
        Project.UpdateFile;
      end;
    end;
  finally
    RemoveUnitForm.Free;
  end;
  {$ENDIF}
end;

procedure TMainForm.RemoveFilefromprojectPopItemClick(Sender: TObject);
var i : integer;
begin
  for i := 0 to Project.UnitCount - 1 do
    if Project.Units[i].Node = ProjectView.Selected then begin
       Project.Remove(i);
       break;
    end;
end;

procedure TMainForm.RenamefilePopItemClick(Sender: TObject);
var i : integer;
    s : string;
begin
  for i := 0 to Project.UnitCount - 1 do
    if Project.Units[i].Node = ProjectView.Selected then begin
       s := ExtractFilePath(Project.Units[i].FileName);
       if InputQuery('Rename file','File shoud be renamed to :', s)
          and (ExtractFileName(s) <> '') then
          try
            RenameFile(Project.Units[i].FileName, s);
            Project.SaveUnitAs(i, s);
            if Project.Units[i].Editor <> nil then
              Project.Units[i].Editor.Caption := ExtractFileName(s);
          except
            MessageDlg('Could not rename file to "'+s+'"', mtError, [mbOK], 0);
          end;
       break;
    end;
end;

procedure TMainForm.ProjecttoHTMLItemClick(Sender: TObject);
var F : TextFile;
    FileName : string;
    i : integer;
begin
  if ProjectOpen = False then
    Exit;
  AssignFile(F, ChangeFileExt(Project.FileName, '.html'));
  Rewrite(F);
  Writeln(F, '<!-- This file was generated by Bloodshed '+Module.Name+' '+DEV_VERSION+' -->');
  Writeln(F, '<!-- http://www.bloodshed.net/ -->');
  Writeln(F, '');
  Writeln(F, '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">');
  Writeln(F, '');
  Writeln(F, '<HTML>');
  Writeln(F, '<HEAD>');
  Writeln(F, '  <META HTTP-EQUIV=Content-Type CONTENT="text/html; charset=iso-8859-1">');
  Writeln(F, '  <META NAME=Generator CONTENT="Bloodshed '+Module.Name+'">');
  Writeln(F, '  <TITLE>'+Project.Name+' project</TITLE>');
  Writeln(F, '</HEAD>');
  Writeln(F, '');
  Writeln(F, '<BODY BGCOLOR=#FFFFFF>');
  Writeln(F, '');
  Writeln(F, '<P><FONT NAME="Arial" COLOR=#000080><STRONG><H1>'+Module.Name+' Project : ' +
    Project.Name + '</H1></STRONG></FONT></P>');
  Writeln(F, '');
  FileName := Project.GetExecutableName;
  if FileExists(FileName) then
     Writeln(F, '<P><STRONG>Compiled on : ' + DateTimeToStr(FileDateToDateTime(Fileage(FileName))) + '</STRONG></P>');
  Writeln(F, '<TABLE BORDER=1>');
  Writeln(F, '<TR><TD COLSPAN=2><STRONG>Unit information</STRONG></TD></TR>');

  for i := 0 to Project.UnitCount-1 do begin
     Writeln(F, '<TR>');
     Writeln(F, '  <TD>Unit ' + IntToStr(i + 1) + ' : </TD>');
     Writeln(F, '  <TD>' + Project.Units[i].FileName + '</TD>');
     Writeln(F, '</TR>');
  end;
  Writeln(F, '</TABLE>');
  Writeln(F, '');
  Writeln(F, '<P><STRONG>Project settings : </STRONG></P>');
  {$IFDEF CPP}
  if Project.UseGpp then
     Writeln(F, '<P>C++ : YES<BR>')
  else
     Writeln(F, '<P>C++ : NO<BR>');
  {$ELSE}
   Writeln(F, '<P>MainUnit : '+Project.MainUnit+'<BR>');
  {$ENDIF}

  Writeln(F, 'Number of unit : ' + IntToStr(Project.UnitCount) + '<BR>');
  if Project.NoConsole = True then
     Writeln(F, 'Create a console : NO<BR>')
  else
     Writeln(F, 'Create a console : YES<BR>');
  Writeln(F, 'Object files or linker options : ' + Project.ObjFiles + '<BR>');
  Writeln(F, 'Compiler options : ' + Project.Libs + '<BR>');
  Writeln(F, 'Compiler options : ' + Project.CompilerOptions + '<BR>');
  Writeln(F, 'Include directories : ' + Project.IncludeDirs + '<BR>');
  if Project.StaticLib then
     Writeln(F, 'Static library : YES<BR>')
  else if Project.DynamicLib then
     Writeln(F, 'Dynamic Library : YES<BR>');

  Writeln(F, '</P>');
  Writeln(F, '');
  Writeln(F, '</BODY>');
  Write(F, '</HTML>');

  CloseFile(F);
  MessageDlg('Your project has been converted to HTML in file ' +
             ChangeFileExt(Project.FileName, '.html'), MtInformation, [mbOK], 0);
end;

procedure TMainForm.CompilandRunItemClick(Sender: TObject);
begin
  CompileBtnClick(sender);
  if (ProjectOpen and FileExists(Project.GetExecutableName)) or
     ((PageControl.ActivePageIndex > - 1) and FileExists(ChangeFileExt((PageControl.ActivePage as TEditor).Filename, ''))) then
     ExecuteProgram('');
end;

procedure TMainForm.RebuildBtnClick(Sender: TObject);
begin
  if ProjectOpen then begin
    chdir(ExtractFilePath(Project.FileName));
    Logbox.Lines.Add('Cleaning files...');
    LogBox.Lines.Add(Module.Make+ ' -f '+ExtractFilePath(Project.FileName) + DEV_MAKEFILE+' clean');
    ExecuteFile(Module.Make, '-f '+ExtractFilePath(Project.FileName) + DEV_MAKEFILE+' clean', true);
    CompileProject;
  end
  else begin
    if FileExists(ChangeFileExt((PageControl.ActivePage as TEditor).Filename, '')) then
      DeleteFile((PageControl.ActivePage as TEditor).Filename);
    CompileFile;
  end;
end;

procedure TMainForm.MakeSheetShow(Sender: TObject);
begin
  if (MakeSheet.Highlighted) then
    MakeSheet.Highlighted := false;
end;

procedure TMainForm.CompSheetShow(Sender: TObject);
begin
  if (CompSheet.Highlighted) then
    CompSheet.Highlighted := false;
end;

procedure TMainForm.FindDialogFind(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    (PageControl.ActivePage as TEditor).Find;
end;

procedure TMainForm.ReplaceDialogReplace(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    (PageControl.ActivePage as TEditor).Replace;
end;

procedure TMainForm.ReplaceDialogFind(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    (PageControl.ActivePage as TEditor).FindReplace;
end;

procedure TMainForm.FindItemClick(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    FindDialog.Execute;
end;

procedure TMainForm.ReplaceItemClick(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    ReplaceDialog.Execute;
end;

procedure TMainForm.FindnextItemClick(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    (PageControl.ActivePage as TEditor).Find;
end;

procedure TMainForm.UndoItemClick(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    (PageControl.ActivePage as TEditor).Text.Undo;
end;

procedure TMainForm.RedoItemClick(Sender: TObject);
begin
  if (PageControl.ActivePageIndex > -1) then
    (PageControl.ActivePage as TEditor).Text.Redo;
end;

procedure TMainForm.InsertbtnClick(Sender: TObject);
begin
  InsertMenu.Popup(InsertBtn.ClientOrigin.x+InsertBtn.Width, InsertBtn.ClientOrigin.y);
end;

procedure TMainForm.ToggleBtnClick(Sender: TObject);
begin
  ToggleMenu.Popup(ToggleBtn.ClientOrigin.x+ToggleBtn.Width, ToggleBtn.ClientOrigin.y);
end;

procedure TMainForm.GotoBtnClick(Sender: TObject);
begin
  GotoMenu.Popup(GotoBtn.ClientOrigin.x+GotoBtn.Width, GotoBtn.ClientOrigin.y);
end;

procedure TMainForm.ToggleBookmark(Sender: TObject);
var
  BookMark, X, Y: integer;
begin
  if PageControl.ActivePageIndex > -1 then begin
    (Sender as TMenuItem).Checked:= not (Sender as TMenuItem).Checked;
    if (Sender as TMenuItem).Checked then begin
       BookMark := (Sender as TMenuItem).Tag;
       X := (PageControl.ActivePage as TEditor).Text.CaretX;
       Y := (PageControl.ActivePage as TEditor).Text.CaretY;
       (PageControl.ActivePage as TEditor).Text.SetBookMark(BookMark, X, Y);
    end
    else
      (PageControl.ActivePage as TEditor).Text.ClearBookMark((Sender as TMenuItem).Tag);
  end;
end;

procedure TMainForm.GotoBookmark(Sender: TObject);
begin
  if PageControl.ActivePageIndex > - 1 then
    (PageControl.ActivePage as TEditor).Text.GotoBookMark((Sender as TMenuItem).Tag);
end;

procedure TMainForm.OpenMessageSheet;
begin
  MessageControl.Height := MessageOriginalHeight;
  MessageControl.ActivePage := CompSheet;
  CloseSheet.Caption := 'Close';
  CloseSheet.ImageIndex := 4;
end;

procedure TMainForm.CloseMessageSheet;
begin
  MessageControl.Height := CompSheet.Font.Height + CompSheet.Font.Size;
  MessageControl.ActivePage := CompSheet;
  CloseSheet.Caption := 'Open';
  CloseSheet.ImageIndex := 32;
end;

procedure TMainForm.OpenCloseMessageSheet;
begin
  if MessageControl.ActivePage = CloseSheet then begin
    if MessageControl.Height = MessageOriginalHeight then
       CloseMessageSheet
    else
       OpenMessageSheet; 
  end
end;

procedure TMainForm.MessageControlChange(Sender: TObject);
begin
  OpenCloseMessageSheet;
end;

procedure TMainForm.MessageControlResize(Sender: TObject);
begin
  if (MessageControl.Height <> MessageOriginalHeight) and
     (MessageControl.Height <> Compsheet.Font.Height + CompSheet.Font.Size) then
     MessageOriginalHeight := MessageControl.Height;
end;

procedure TMainForm.ShowOnlyWhenNeedClick(Sender: TObject);
begin
  AlwaysShow.Checked := not AlwaysShow.Checked;
  ShowOnlyWhenNeed.Checked := not ShowOnlyWhenNeed.Checked;
  CloseMessageSheet;
end;

procedure TMainForm.AlwaysShowClick(Sender: TObject);
begin
  AlwaysShow.Checked := not AlwaysShow.Checked;
  ShowOnlyWhenNeed.Checked := not ShowOnlyWhenNeed.Checked;
  OpenMessageSheet;
end;

end.
