unit pas_compoptions;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QButtons, QStdCtrls, Inifiles, QExtCtrls, QComCtrls, version;

type
  TPas_CompForm = class(TForm)
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    DefaultBtn: TBitBtn;
    PageControl: TPageControl;
    PasTab: TTabSheet;
    Panel1: TPanel;
    CodeGenTab: TTabSheet;
    LinkerTab: TTabSheet;
    DirTab: TTabSheet;
    Panel3: TPanel;
    Panel4: TPanel;
    DebugInfo: TCheckBox;
    Panel6: TPanel;
    AddDir: TCheckBox;
    AddDirEdit: TEdit;
    ComCheck: TCheckBox;
    Commands: TEdit;
    Label2: TLabel;
    Label4: TLabel;
    ePasdir: TEdit;
    eLibDir: TEdit;
    GroupBox1: TGroupBox;
    DelphiExt: TCheckBox;
    COp: TCheckBox;
    LabelGoto: TCheckBox;
    GroupBox3: TGroupBox;
    SmallCode: TCheckBox;
    Best: TCheckBox;
    QuickOpt: TCheckBox;
    GroupBox4: TGroupBox;
    IOCheck: TCheckBox;
    StackCheck: TCheckBox;
    Overflow: TCheckBox;
    Panel2: TPanel;
    Label6: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    GroupBox5: TGroupBox;
    LinkDyn: TCheckBox;
    HelpBtn: TBitBtn;
    Assert: TCheckBox;
    DelphiComp: TCheckBox;
    Ansi: TCheckBox;
    CInline: TCheckBox;
    TP7: TCheckBox;
    Macros: TCheckBox;
    LinkSmart: TCheckBox;
    StripSymbols: TCheckBox;
    NoReloc: TCheckBox;
    NoCheckUnit: TCheckBox;
    MakeLabel: TLabel;
    MakeEdit: TEdit;
    MakeBtn: TSpeedButton;
    PpcBtn: TSpeedButton;
    PpcEdit: TEdit;
    Label1: TLabel;
    OpenDialog: TOpenDialog;
    procedure CancelBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DefaultBtnClick(Sender: TObject);
    procedure MakeBtnClick(Sender: TObject);
    procedure PpcBtnClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  NumOpt : integer;

implementation
uses Main, dev_module;
{$R *.xfm}

procedure TPas_CompForm.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TPas_CompForm.OkBtnClick(Sender: TObject);
begin
  CompilerOptionsModified := True;

  if AddDir.Checked and (AddDirEdit.Text = '') then
     begin
          MessageDlg('You have selected the "Add directory" option but no path have been typed in the field below.', MtError,[MbOK],0);
          AddDir.Checked := False;
     end;

  if ComCheck.Checked and (Commands.Text = '') then
     begin
          MessageDlg('You have selected the "Add commands" option but no commands have been typed in the field below.', MtError,[MbOK],0);
          ComCheck.Checked := False;
     end;

  { Write to the ini file the user's desired compiler options }
  with MainForm do begin
  IniFile.WriteBool('Pascal_Compiler','DelphiExt',DelphiExt.Checked);
  IniFile.WriteBool('Pascal_Compiler','Assert',Assert.Checked);
  IniFile.WriteBool('Pascal_Compiler','Ansi',Ansi.Checked);
  IniFile.WriteBool('Pascal_Compiler','TP7',TP7.Checked);
  IniFile.WriteBool('Pascal_Compiler','COp',COp.Checked);
  IniFile.WriteBool('Pascal_Compiler','LabelGoto',LabelGoto.Checked);
  IniFile.WriteBool('Pascal_Compiler','DelphiComp',DelphiComp.Checked);
  IniFile.WriteBool('Pascal_Compiler','CInline',CInline.Checked);
  IniFile.WriteBool('Pascal_Compiler','Macros',Macros.Checked);
  IniFile.WriteBool('Pascal_Compiler','LinkDyn',LinkDyn.Checked);
  IniFile.WriteBool('Pascal_Compiler','LinkSmart',LinkSmart.Checked);
  IniFile.WriteBool('Pascal_Compiler','StripSymbols',StripSymbols.Checked);
  IniFile.WriteBool('Pascal_Compiler','NoCheckUnit',NoCheckUnit.Checked);

  IniFile.WriteBool('Code_Generation','IOCheck',IOCheck.Checked);
  IniFile.WriteBool('Code_Generation','StackCheck',StackCheck.Checked);
  IniFile.WriteBool('Code_Generation','Overflow',Overflow.Checked);

  IniFile.WriteBool('Optimization','SmallCode',SmallCode.Checked);
  IniFile.WriteBool('Optimization','QuickOpt',QuickOpt.Checked);
  IniFile.WriteBool('Optimization','Best',Best.Checked);

  IniFile.WriteBool('Linker','DebugInfo',DebugInfo.Checked);
  IniFile.WriteBool('Linker','NoReloc',NoReloc.Checked);

  if AddDir.Checked then
     begin
       IniFile.WriteBool('Directories','AddDir',AddDir.Checked);
       IniFile.WriteString('Directories','Dir',AddDirEdit.Text);
     end
  else
     begin
       IniFile.WriteBool('Directories','AddDir',False);
       IniFile.WriteString('Directories','Dir','');
     end;

  if ComCheck.Checked then
     begin
       IniFile.WriteBool('Directories','AddCommands',ComCheck.Checked);
       IniFile.WriteString('Directories','Commands',Commands.Text);
     end
  else
     begin
       IniFile.WriteBool('Directories','AddCommands',False);
       IniFile.WriteString('Directories','Commands','');
     end;

  IniFile.WriteString('dev','make_dir',MakeEdit.Text);
  IniFile.WriteString('dev','Ppc_dir',PpcEdit.Text);
  Module.Make := MakeEdit.Text;
  Module.Compiler := PpcEdit.Text;

  IniFile.WriteString('Directories','PasDir',ePasDir.Text);
  IniFile.WriteString('Directories','LibDir',eLibDir.Text);
  end;
end;

procedure TPas_CompForm.FormActivate(Sender: TObject);
begin
   { Read from the ini file the user's desired compiler options }
  with Mainform do begin
  DelphiExt.Checked := IniFile.ReadBool('Pascal_Compiler','DelphiExt',True);
  Assert.Checked := IniFile.ReadBool('Pascal_Compiler','Assert',False);
  Ansi.Checked := IniFile.ReadBool('Pascal_Compiler','Ansi',False);
  TP7.Checked := IniFile.ReadBool('Pascal_Compiler','TP7',True);
  COp.Checked := IniFile.ReadBool('Pascal_Compiler','COp',False);
  LabelGoto.Checked := IniFile.ReadBool('Pascal_Compiler','LabelGoto',True);
  DelphiComp.Checked := IniFile.ReadBool('Pascal_Compiler','DelphiComp',True);
  CInline.Checked := IniFile.ReadBool('Pascal_Compiler','CInline',False);
  Macros.Checked := IniFile.ReadBool('Pascal_Compiler','Macros',False);
  LinkDyn.Checked := IniFile.ReadBool('Pascal_Compiler','LinkDyn',False);
  LinkSmart.Checked := IniFile.ReadBool('Pascal_Compiler','LinkSmart',False);
  StripSymbols.Checked := IniFile.ReadBool('Pascal_Compiler','StripSymbols',False);
  NoCheckUnit.Checked := IniFile.ReadBool('Pascal_Compiler','NoCheckUnit',True);

  IOCheck.Checked := IniFile.ReadBool('Code_Generation','IOCheck',False);
  StackCheck.Checked := IniFile.ReadBool('Code_Generation','StackCheck',False);
  Overflow.Checked := IniFile.ReadBool('Code_Generation','Overflow',False);

  SmallCode.Checked := IniFile.ReadBool('Optimization','SmallCode',False);
  QuickOpt.Checked := IniFile.ReadBool('Optimization','QuickOpt',True);
  Best.Checked := IniFile.ReadBool('Optimization','Best',False);

  DebugInfo.Checked := IniFile.ReadBool('Linker','DebugInfo',False);
  NoReloc.Checked := IniFile.ReadBool('Linker','NoReloc',False);

  AddDir.Checked := IniFile.ReadBool('Directories','AddDir',AddDir.Checked);
  AddDirEdit.Text := IniFile.ReadString('Directories','Dir',AddDirEdit.Text);
  ComCheck.Checked := IniFile.ReadBool('Directories','AddCommands',ComCheck.Checked);
  Commands.Text := IniFile.ReadString('Directories','Commands',Commands.Text);

  MakeEdit.Text := IniFile.ReadString('dev', 'make_dir', MAKE);
  PpcEdit.Text := IniFile.ReadString('dev', 'ppc_dir', PPC386);

  ePasDir.Text := IniFile.ReadString('Directories','PasDir',ePasDir.Text);
  eLibDir.Text := IniFile.ReadString('Directories','LibDir',eLibDir.Text);
  end;
end;

procedure TPas_CompForm.DefaultBtnClick(Sender: TObject);
begin
{ Set default compiler options }
  DelphiExt.Checked := True;
  Assert.Checked := False;
  Ansi.Checked := false;
  TP7.Checked := True;
  COp.Checked := False;
  LabelGoto.Checked := True;
  DelphiComp.Checked := True;
  CInline.Checked := False;
  Macros.Checked := False;
  LinkDyn.Checked := False;
  LinkSmart.Checked := False;
  StripSymbols.Checked := False;
  NoCheckUnit.Checked := True;

  IOCheck.Checked := False;
  StackCheck.Checked := False;
  Overflow.Checked := False;
  SmallCode.Checked := False;
  QuickOpt.Checked := True;
  Best.Checked := False;
  DebugInfo.Checked := False;
  NoReloc.Checked := False;

  AddDir.Checked := False;
  AddDirEdit.Text := '';
  ComCheck.Checked := False;
  Commands.Text := '';

  MakeEdit.Text := MAKE;
  PpcEdit.Text := PPC386;
end;

procedure TPas_CompForm.MakeBtnClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    MakeEdit.Text := OpenDialog.FileName;
end;

procedure TPas_CompForm.PpcBtnClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    PpcEdit.Text := OpenDialog.FileName;
end;


end.
