{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Colin Laplace                            *
*                                                    *
*  projectoptions.pas : Project options window       *
*                                                    *
******************************************************
}
unit projectoptions;

interface

uses
  SysUtils, Classes, QGraphics, QForms, QDialogs, QStdCtrls,
  QControls, QExtCtrls, QButtons;

type
  TProjectOpt = class(TForm)
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel: TPanel;
    GroupBox2: TGroupBox;
    CompileCpp: TCheckBox;
    GroupBox3: TGroupBox;
    ObjFileName: TEdit;
    Label1: TLabel;
    OpenDialog: TOpenDialog;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    ProjectName: TEdit;
    NoConsole: TCheckBox;
    DynLib: TCheckBox;
    HelpBtn: TBitBtn;
    Label4: TLabel;
    CompilerOpt: TEdit;
    Label5: TLabel;
    IncDir: TEdit;
    Label3: TLabel;
    Extralib: TEdit;
    StaticLib: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Dclarations prives }
  public
    IconFileName : string;
    { Dclarations publiques }
  end;

var
  ProjectOpt: TProjectOpt;

implementation

uses infofrm;

{$R *.xfm}

procedure TProjectOpt.BitBtn1Click(Sender: TObject);
var
  i: Integer;
  Txt: String;
begin
  OpenDialog.FilterIndex := 1;
  Txt := '';
  if OpenDialog.Execute then begin
     for i := 0 to OpenDialog.Files.Count - 1 do
        Txt := Txt + ' ' + OpenDialog.Files.Strings[i];
     Delete(Txt, 1, 1);
     ObjFileName.Text := ObjFileName.Text+' '+Txt;
  end;
end;

procedure TProjectOpt.BitBtn2Click(Sender: TObject);
var
  i: Integer;
  Txt: String;
begin
  Txt := '';
  OpenDialog.FilterIndex := 4;
  if OpenDialog.Execute then begin
     for i := 0 to OpenDialog.Files.Count - 1 do
        Txt := Txt + ' ' + OpenDialog.Files.Strings[i];
     Delete(Txt, 1, 1);
  end;
end;
 procedure TProjectOpt.FormActivate(Sender: TObject);
begin
{$IFDEF CPP}
  CompileCpp.Visible := True;
{$ENDIF}
end;


end.
