{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Colin Laplace                            *
*                                                    *
*  splash.pas : splash screen                        *
*                                                    *
******************************************************
}
unit splash;

interface

uses
  SysUtils, Classes, QForms, QDialogs,
  Version, QComCtrls, QGraphics, QControls, QExtCtrls;

type
  TSplashForm = class(TForm)
    Panel: TPanel;
    {$IFDEF CPP}
    CppImage: TImage;
    {$ELSE}
    PasImage: TImage;
    {$ENDIF}
    StatusBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  SplashForm: TSplashForm;

implementation

{$R *.xfm}

procedure TSplashForm.FormCreate(Sender: TObject);
begin
  {$IFDEF PAS}
  PasImage.Visible := True;
  {$ELSE}
  CppImage.Visible := True;
  {$ENDIF}
  StatusBar.SimpleText := 'Version '+Dev_Version+' Loading...';
end;

end.
