{
******************************************************
*                                                    *
*    Dev-IDE source code (Dev-C++/Dev-Pascal)        *
*                for Linux/Qt                        *
*                                                    *
*  Author : Hongli Lai, Colin Laplace                *
*                                                    *
*  templatefrm.pas : Template creator                *
*                                                    *
******************************************************
}
unit templatefrm;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QButtons, QStdCtrls, QComCtrls, QMenus, QExtCtrls,
  QClipbrd, IniFiles, QImgList, QTypes;

type
  TTemplateForm = class(TForm)
    MainMenu: TMainMenu;
    ToolBar: TToolBar;
    PageControl: TPageControl;
    StatusBar: TStatusBar;
    TemplateSheet: TTabSheet;
    CSheet: TTabSheet;
    NewBtn: TToolButton;
    OpenBtn: TToolButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    NameEdit: TEdit;
    Label2: TLabel;
    Description: TEdit;
    Label3: TLabel;
    Catagory: TEdit;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    C_col: TSpinEdit;
    Label6: TLabel;
    c_row: TSpinEdit;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Param: TEdit;
    Label8: TLabel;
    ProjectName: TEdit;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    N1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Delete1: TMenuItem;
    N2: TMenuItem;
    SelectAll1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    HelpContents1: TMenuItem;
    N5: TMenuItem;
    NewWindow1: TMenuItem;
    SaveBtn: TToolButton;
    ExitBtn: TToolButton;
    ToolButton1: TToolButton;
    Image2: TImage;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    NewWindowBtn: TToolButton;
    ToolButton3: TToolButton;
    ImageList: TImageList;
    Panel2: TPanel;
    EnableC: TCheckBox;
    CppSheet: TTabSheet;
    Panel3: TPanel;
    EnableCpp: TCheckBox;
    PopupMenu1: TPopupMenu;
    MenuItem2: TMenuItem;
    MenuItem7: TMenuItem;
    Undo2: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    Delete2: TMenuItem;
    SelectAll2: TMenuItem;
    l2: TLabel;
    l1: TLabel;
    cpp_row: TSpinEdit;
    cpp_col: TSpinEdit;
    l3: TLabel;
    l4: TLabel;
    Label14: TLabel;
    CompilerOpt: TEdit;
    GroupBox4: TGroupBox;
    ConsoleBox: TCheckBox;
    CppBox: TCheckBox;
    CheckBox3: TCheckBox;
    IncDir: TEdit;
    Label15: TLabel;
    CCode: TMemo;
    CppCode: TMemo;
    DynlibBox: TCheckBox;
    StaticLibBox: TCheckBox;
    procedure SpinEdit4Change(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure NewWindow1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure AppHint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FFileName: String;
    Function GetFileName: String;
    procedure SetFileName(Value: String);
  public
    Modified: Boolean;
    procedure Open(Const AFileName: String);
    procedure Save(AFileName: String);
    property FileName: String read GetFileName write SetFileName;
  end;

var
  TemplateForm: TTemplateForm;

implementation

uses
  dev_module, version;

{$R *.xfm}

Const
  sUntitled = UNTITLED;
  sAppName = 'Template Builder';
  sStdCCode =
    '#include <stdio.h>' + #13#10 +
    '#include <stdlib.h>' + #13#10 +
    '#include <windows.h>' + #13#10 +
    '' + #13#10 +
    'int main (int argc, char *argv[])' + #13#10 +
    '{' + #13#10 +
    '   /* Put your C codes here */' + #13#10 +
    '   return 0;' + #13#10 +
    '}';
  sStdCppCode =
    '#include <iostream.h>' + #13#10 +
    '#include <stdlib.h>' + #13#10 +
    '#include <windows.h>' + #13#10 +
    '' + #13#10 +
    'int main (int argc, char *argv[])' + #13#10 +
    '{' + #13#10 +
    '   /* Put your C++ codes here */' + #13#10 +
    '   return 0;' + #13#10 +
    '}';

procedure TTemplateForm.SpinEdit4Change(Sender: TObject);
begin
  if (length(TSpinEdit(Sender).Text) > 0) and (TSpinEdit(Sender).Value < 0) then
     TSpinEdit(Sender).Value := 0;

  EditChange(Sender);
end;

procedure TTemplateForm.Cut1Click(Sender: TObject);
begin
  TCustomEdit(ActiveControl).CutToClipboard;
end;

procedure TTemplateForm.Copy1Click(Sender: TObject);
begin
  TCustomEdit(ActiveControl).CopyToClipboard;
end;

procedure TTemplateForm.Paste1Click(Sender: TObject);
begin
  TCustomEdit(ActiveControl).PasteFromClipboard;
end;

procedure TTemplateForm.Delete1Click(Sender: TObject);
begin
  TCustomEdit(ActiveControl).ClearSelection;
end;

procedure TTemplateForm.SelectAll1Click(Sender: TObject);
begin
  TCustomEdit(ActiveControl).SelectAll;
end;

procedure TTemplateForm.Edit1Click(Sender: TObject);
var
  E: Boolean;
begin
  E := ActiveControl is TCustomEdit;
  Undo1.Enabled := E;
  Cut1.Enabled := E;
  Copy1.Enabled := E;
  Paste1.Enabled := E;
  Delete1.Enabled := E;
  SelectAll1.Enabled := E;
  if E then
  begin
//     Undo1.Enabled := TCustomEdit(ActiveControl).Perform(EM_CANUNDO, 0, 0) = 1;
     Cut1.Enabled := TCustomEdit(ActiveControl).SelLength > 0;
     Copy1.Enabled := TCustomEdit(ActiveControl).SelLength > 0;
     Delete1.Enabled := TCustomEdit(ActiveControl).SelLength > 0;
     Paste1.Enabled := Clipboard.AsText <> '';
  end;
end;

procedure TTemplateForm.NewWindow1Click(Sender: TObject);
begin
  TemplateForm := TTemplateForm.Create(application);
  TemplateForm.Show;
end;

procedure TTemplateForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TTemplateForm.EditChange(Sender: TObject);
begin
  Modified := True;
end;

procedure TTemplateForm.CheckBoxClick(Sender: TObject);
begin
  Modified := True;
end;

procedure TTemplateForm.FormCreate(Sender: TObject);
begin
  Modified := False;
  SaveDialog1.InitialDir := Module.TemplateDir;
  {$IFDEF PAS}
  CppSheet.Visible := False;
  CppSheet.TabVisible := false;
  CSheet.Caption := 'Pascal code';
  CppBox.Visible := False;
  Cpp_Row.Visible := False;
  Cpp_col.Visible := False;
  l1.Visible := False;
  l2.Visible := False;
  l3.Visible := False;
  l4.Visible := False;
  EnableC.Visible := False;
  EnableCpp.Visible := False;
  {$ENDIF}
end;

procedure TTemplateForm.AppHint(Sender: TObject);
begin
  StatusBar.Panels.Items[0].Text := GetLongHint(Application.Hint);
end;


procedure TTemplateForm.Open(Const AFileName: String);
var
  Ini: TIniFile;
  F: String;
begin
  Ini := TIniFile.Create(AFileName);
  NameEdit.Text := Ini.ReadString('Template', 'Name', 'My Template');
  Description.Text := Ini.ReadString('Template', 'Description',
    'A simple template.');
  Catagory.Text := Ini.ReadString('Template', 'Catagory', 'Additional');

  CCode.Lines.Text := sStdCCode;
  CppCode.Lines.Text := sStdCppCode;

  c_col.Value := Ini.ReadInteger('Editor', 'CursorX', 0);
  c_row.Value := Ini.ReadInteger('Editor', 'CursorY', 0);
  {$IFDEF CPP}
  F := Ini.ReadString('Editor', 'Text', ChangeFileExt(ExtractFileName(AFileName), '_c.txt'));
  if FileExists(F) then
    CCode.Lines.LoadFromFile(F);
  F := Ini.ReadString('Editor', 'Text_Cpp', ChangeFileExt(ExtractFileName(AFileName), '_cpp.txt'));
  if FileExists(F) then
    CppCode.Lines.LoadFromFile(F);
  cpp_col.Value := Ini.ReadInteger('Editor', 'CursorX_Cpp', 0);
  cpp_row.Value := Ini.ReadInteger('Editor', 'CursorY_Cpp', 0);
  CppBox.Checked := Ini.ReadBool('Project', 'Cpp', True);
  EnableC.Checked := Ini.ReadBool('Template', 'EnableC', True);
  EnableCpp.Checked := Ini.ReadBool('Template', 'EnableCpp', True);
  {$ELSE}
  F := Ini.ReadString('Editor', 'Text', ChangeFileExt(ExtractFileName(AFileName), '.txt'));
  if FileExists(F) then
    CCode.Lines.LoadFromFile(F);
  {$ENDIF}
  ConsoleBox.Checked := Ini.ReadBool('Project', 'Console', True);
  StaticLibBox.Checked := Ini.ReadBool('Project', 'static', False);
  DynLibBox.Checked := Ini.ReadBool('Project', 'dynamic', False);
  CompilerOpt.Text := Ini.ReadString('Project', 'CompilerOptions', '');
  IncDir.Text := Ini.ReadString('Project', 'IncludeDirs', '');
  Param.Text := Ini.ReadString('Project', 'Libs', '');
  ProjectName.Text := Ini.ReadString('Project', 'Name', 'Project1');
  Ini.Free;
  FileName := AFileName;
end;

procedure TTemplateForm.Save(AFileName: String);
var
  Ini : TIniFile;
begin
  if UpperCase(ExtractFileExt(AFileName)) = '.TEM' then
     AFileName := ChangeFileExt(AFileName, '.template');
  Ini := TIniFile.Create(AFileName);
  Ini.WriteString('Template', 'Name', NameEdit.Text);
  Ini.WriteString('Template', 'Description', Description.Text);
  Ini.WriteString('Template', 'Catagory', Catagory.Text);

  {$IFDEF CPP}
  Ini.WriteBool('Template', 'EnableC', EnableC.Checked);
  Ini.WriteBool('Template', 'EnableCpp', EnableCpp.Checked);
  if EnableC.Checked then begin
     Ini.WriteString('Editor', 'Text', ChangeFileExt(ExtractFileName(AFileName),
       '_c.txt'));
     CCode.Lines.SaveToFile(ChangeFileExt(ExtractFileName(AFileName), '_c.txt'));
  end;
  if EnableCpp.Checked then begin
     Ini.WriteString('Editor', 'Text_Cpp', ChangeFileExt(ExtractFileName(AFileName),
       '_cpp.txt'));
     CppCode.Lines.SaveToFile(ChangeFileExt(ExtractFileName(AFileName), '_cpp.txt'));
  end;
  Ini.WriteInteger('Editor', 'CursorX_Cpp', cpp_col.Value);
  Ini.WriteInteger('Editor', 'CursorY_Cpp', cpp_row.Value);
  Ini.WriteBool('Project', 'Cpp', CppBox.Checked);
  {$ELSE}
  Ini.WriteString('Editor', 'Text', ChangeFileExt(ExtractFileName(AFileName), '.txt'));
  CCode.Lines.SaveToFile(ChangeFileExt(ExtractFileName(AFileName), '.txt'));
  {$ENDIF}
  Ini.WriteInteger('Editor', 'CursorX', c_col.Value);
  Ini.WriteInteger('Editor', 'CursorY', c_row.Value);
  Ini.WriteBool('Project', 'Console', ConsoleBox.Checked);
  Ini.WriteBool('Project', 'static', StaticLibBox.Checked);
  Ini.WriteBool('Project', 'dynamic', DynLibBox.Checked);
  Ini.WriteString('Project', 'CompilerOptions', CompilerOpt.Text);
  Ini.WriteString('Project', 'IncludeDirs', IncDir.Text);
  Ini.WriteString('Project', 'Libs', Param.Text);
  Ini.WriteString('Project', 'Name', ProjectName.Text);
  Ini.UpdateFile;
  Ini.Free;
  FileName := AFileName;
end;

Function TTemplateForm.GetFileName: String;
begin
  Result := FFileName;
end;

procedure TTemplateForm.SetFileName(Value: String);
begin
  FFileName := Value;
  Modified := False;
  if Value = '' then
     Caption := sAppName + ' - ' + sUntitled
  else
     Caption := sAppName + ' - ' + ExtractFileName(Value);
end;

procedure TTemplateForm.PopupMenu1Popup(Sender: TObject);
var
  E: Boolean;
begin
  E := ActiveControl is TCustomEdit;
  Undo2.Enabled := E;
  Cut2.Enabled := E;
  Copy2.Enabled := E;
  Paste2.Enabled := E;
  Delete2.Enabled := E;
  SelectAll2.Enabled := E;
  if E then
  begin
//     Undo2.Enabled := TCustomEdit(ActiveControl).Perform(EM_CANUNDO, 0, 0) = 1;
     Cut2.Enabled := TCustomEdit(ActiveControl).SelLength > 0;
     Copy2.Enabled := TCustomEdit(ActiveControl).SelLength > 0;
     Delete2.Enabled := TCustomEdit(ActiveControl).SelLength > 0;
     Paste2.Enabled := Clipboard.AsText <> '';
  end;
end;

procedure TTemplateForm.Save1Click(Sender: TObject);
begin
  if FileExists(FileName) then
     Save(FileName)
  else
     SaveAs1Click(Sender);
end;

procedure TTemplateForm.SaveAs1Click(Sender: TObject);
{var
  Ini : TIniFile;
  j   : integer;}
begin
  if SaveDialog1.Execute then begin
     Save(SaveDialog1.FileName);
  end;
end;

procedure TTemplateForm.New1Click(Sender: TObject);
begin
  if Modified then
  begin
     if MessageDlg('This template has been modified.' + #13#10 +
       'Do you want to save it?', 'Confirm', mtConfirmation, [mbYes, mbOk], 0) = mrYes then
     begin
        Save1Click(Sender);
        if Modified then Exit;
     end else
        Exit;
  end;

  FileName := '';
  NameEdit.Text := 'My Template';
  Description.Text := 'A simple template.';
  Catagory.Text := 'Additional';
  c_col.Value := 0;
  c_row.Value := 0;
  ProjectName.Text := 'Project1';
  Param.Text := '';
  ConsoleBox.Checked := True;
  CppBox.Checked := True;
  StaticLibBox.Checked := False;
  DynLibBox.Checked := False;
  CCode.Lines.Text := sStdCCode;
  {$IFDEF CPP}
  cpp_col.value := 0;
  cpp_row.Value := 0;
  CppCode.Lines.Text := sStdCppCode;
  {$ENDIF}
end;

procedure TTemplateForm.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
     Open(OpenDialog1.FileName);
end;

procedure TTemplateForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
